#ifndef DVISEL_H
#define DVISEL_H

#include <stdio.h> /* for FILE * */

/*
 * select pages from a DVI file.
 *
 * Copyright (c) 1999
 *      WATANABE Takeshi        watanabe@komadori.planet.sci.kobe-u.ac.jp
 * Copyright (c) 2002  the xdvik project team
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT.  IN NO EVENT SHALL ANY AUTHO OF THIS SOFTWARE BE
 * LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

/* info for pages to be selected */
struct select_pages_t {
    int from;
    int to;
};

/* stacks for communication with selection routines */
struct specials_stack_elem_t {
    char *content;		/* string content */
};

struct specials_stack_t {
    size_t stack_len;
    struct specials_stack_elem_t *items;
};

/* functions for selecting/pringing pages */
/*  Boolean select_marked_pages(FILE *fp, struct specials_stack_t *stack); */
/*  Boolean select_pagerange(FILE *fp, int from, int to, struct specials_stack_t *stack); */
Boolean check_pagerange(struct select_pages_t *info, int pageno);
Boolean check_marked(struct select_pages_t *info, int pageno);
Boolean select_pages(FILE *fp, Boolean (*callback)(), struct select_pages_t *info, struct specials_stack_t *stack);
Boolean copy_file(FILE *fp, struct specials_stack_t *stack);

#endif /* DVISEL_H */
